"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.browser = exports.context = exports.page = void 0;
// @ts-nocheck
require("dotenv").config({ path: ".env.platform" });
var cucumber_1 = require("@cucumber/cucumber");
var test_1 = require("@playwright/test");
var config_1 = require("./config");
var browser_config_1 = require("./browser-config");
var azure_integration_1 = require("../helper/azure-integration");
var actions_1 = require("../helper/actions");
var path = require("path");
var page;
exports.page = page;
var browser;
exports.browser = browser;
var context;
exports.context = context;
var latestScreenShot;
(0, cucumber_1.setDefaultTimeout)(Number(process.env.DEFAULT_TIMEOUT) || 30 * 1000);
(0, cucumber_1.BeforeAll)(function () { return __awaiter(void 0, void 0, void 0, function () {
    var _a, error_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = browser_config_1.browserName[process.env.BROWSER];
                switch (_a) {
                    case "firefox": return [3 /*break*/, 1];
                    case "webkit": return [3 /*break*/, 3];
                    case "edge": return [3 /*break*/, 5];
                    case "chromium": return [3 /*break*/, 7];
                }
                return [3 /*break*/, 9];
            case 1: return [4 /*yield*/, test_1.firefox.launch(config_1.config.browserOptions)];
            case 2:
                exports.browser = browser = _b.sent();
                return [3 /*break*/, 13];
            case 3: return [4 /*yield*/, test_1.webkit.launch(config_1.config.browserOptions)];
            case 4:
                exports.browser = browser = _b.sent();
                return [3 /*break*/, 13];
            case 5: return [4 /*yield*/, ms.launch(config_1.config.browserOptions)];
            case 6:
                exports.browser = browser = _b.sent();
                return [3 /*break*/, 13];
            case 7: return [4 /*yield*/, test_1.chromium.launch(config_1.config.browserOptions)];
            case 8:
                exports.browser = browser = _b.sent();
                // browser = await webkit.launch(config.browserOptions);
                // browser = await firefox.launch(config.browserOptions);
                return [3 /*break*/, 13];
            case 9: return [4 /*yield*/, test_1.webkit.launch(config_1.config.browserOptions)];
            case 10:
                exports.browser = browser = _b.sent();
                return [4 /*yield*/, test_1.firefox.launch(config_1.config.browserOptions)];
            case 11:
                exports.browser = browser = _b.sent();
                return [4 /*yield*/, test_1.chromium.launch(config_1.config.browserOptions)];
            case 12:
                exports.browser = browser = _b.sent();
                _b.label = 13;
            case 13:
                _b.trys.push([13, 16, , 17]);
                exports.context = context = browser.newContext({ /* pass any options */ ignoreHTTPSErrors: true, });
                return [4 /*yield*/, context];
            case 14: return [4 /*yield*/, (_b.sent()).newPage()];
            case 15:
                exports.page = page = _b.sent();
                console.log('\x1b[34m%s\x1b[0m', 'INFO: ' + "Successfully launched ".concat(process.env.BROWSER, " browser"));
                return [3 /*break*/, 17];
            case 16:
                error_1 = _b.sent();
                console.log("An error occured while trying to launch the browser. ".concat(error_1));
                return [3 /*break*/, 17];
            case 17: return [4 /*yield*/, page.setViewportSize({
                    width: 1500,
                    height: 920,
                })];
            case 18:
                _b.sent();
                return [4 /*yield*/, page.goto(config_1.config.BASEURL)];
            case 19:
                _b.sent();
                return [2 /*return*/, page];
        }
    });
}); });
(0, cucumber_1.After)(function (scenario) {
    return __awaiter(this, void 0, void 0, function () {
        var newEmptyObject, startingDir, targetFileName, rootDirectory, rootPath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(scenario.result.status == cucumber_1.Status.FAILED)) return [3 /*break*/, 3];
                    return [4 /*yield*/, azure_integration_1.default.publishTestResults("/".concat(process.env.TEST_PLAN_DATA_FILE), "Failed")];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, azure_integration_1.default.attachScreenShot(latestScreenShot)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    if (!(scenario.result.status == cucumber_1.Status.PASSED)) return [3 /*break*/, 5];
                    return [4 /*yield*/, azure_integration_1.default.publishTestResults("/".concat(process.env.TEST_PLAN_DATA_FILE), "Passed")];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    newEmptyObject = new Object();
                    startingDir = __dirname;
                    targetFileName = 'tsconfig.json';
                    return [4 /*yield*/, actions_1.default.findFilePath(startingDir, targetFileName)];
                case 6:
                    rootDirectory = _a.sent();
                    rootPath = path.resolve(rootDirectory, '../');
                    return [4 /*yield*/, actions_1.default.WriteToJsonFile(process.env.TEST_PLAN_DATA_FILE, newEmptyObject, rootPath)];
                case 7:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
});
(0, cucumber_1.AfterStep)(function (scenario) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(scenario.result.status == cucumber_1.Status.FAILED)) return [3 /*break*/, 3];
                    return [4 /*yield*/, page.screenshot({ path: "screenshots/screenshot.png", fullPage: true })];
                case 1:
                    latestScreenShot = (_a.sent()).toString("base64");
                    return [4 /*yield*/, this.attach(latestScreenShot, 'image/png')];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    });
});
(0, cucumber_1.AfterAll)(function () {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, browser.close()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
});
