"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.findFilePath = exports.writeOrAppendJSONFile = exports.WriteToJsonFile = exports.readFileContent = void 0;
var fs = require("fs");
var path = require("path");
var promises_1 = require("fs/promises");
var readFileContent = function (filePath, rootDirectory) { return __awaiter(void 0, void 0, void 0, function () {
    var fileStore;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                fileStore = "";
                if (rootDirectory) {
                    fileStore += path.join(rootDirectory, filePath);
                }
                if (rootDirectory == null || rootDirectory == undefined) {
                    fileStore += path.join(__dirname, filePath);
                }
                return [4 /*yield*/, (0, promises_1.readFile)(fileStore, "utf8")];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.readFileContent = readFileContent;
/**
 * Function to write to a new file or override the content of the existing file
 * @param filePath
 * @param jsonContent
 * @param rootDirectory
 */
var WriteToJsonFile = function (filePath, jsonContent, rootDirectory) {
    var fileStore = "";
    if (rootDirectory) {
        fileStore += path.join(rootDirectory, filePath);
    }
    if (rootDirectory == null || rootDirectory == undefined) {
        fileStore += path.join(__dirname, filePath);
    }
    fs.writeFile(fileStore, JSON.stringify(jsonContent, null, 2), function (err) {
        if (err) {
            console.log("An error occured while attempting to write to a file", err);
            return;
        }
    });
};
exports.WriteToJsonFile = WriteToJsonFile;
/**
 * Function to write either write or append to a file depending on whether the key exists
 * @param filename
 * @param key
 * @param value
 */
var writeOrAppendJSONFile = function (filename, key, value) { return __awaiter(void 0, void 0, void 0, function () {
    var fileStore, data, jsonData, jsonData;
    var _a;
    return __generator(this, function (_b) {
        fileStore = path.join(__dirname, filename);
        if (fs.existsSync(fileStore)) {
            data = fs.readFileSync(fileStore, 'utf8');
            jsonData = JSON.parse(data);
            if (jsonData.hasOwnProperty(key)) {
                jsonData[key].push(value);
            }
            else {
                jsonData[key] = [value];
            }
            fs.writeFileSync(fileStore, JSON.stringify(jsonData, null, 2));
        }
        else {
            jsonData = (_a = {},
                _a[key] = [value],
                _a);
            fs.writeFileSync(fileStore, JSON.stringify(jsonData, null, 2));
        }
        return [2 /*return*/];
    });
}); };
exports.writeOrAppendJSONFile = writeOrAppendJSONFile;
// Function to search for a file in parent directories
var findFilePath = function (startingDir, targetFileName) { return __awaiter(void 0, void 0, void 0, function () {
    // Helper function to check the existence of the file in the current directory
    function fileExistsInDir(dir, fileName) {
        return fs.existsSync(path.join(dir, fileName));
    }
    // Helper function to get the parent directory
    function getParentDir(dir) {
        return path.resolve(dir, '..');
    }
    var currentDir, filePath;
    return __generator(this, function (_a) {
        currentDir = startingDir;
        // Loop until you reach the root of the file system
        while (currentDir !== getParentDir(currentDir)) {
            if (fileExistsInDir(currentDir, targetFileName)) {
                filePath = path.join(currentDir, targetFileName);
                return [2 /*return*/, filePath];
            }
            // Move up to the parent directory
            currentDir = getParentDir(currentDir);
        }
        return [2 /*return*/, currentDir];
    });
}); };
exports.findFilePath = findFilePath;
