"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.camelCaseString = exports.hyphenateString = exports.removeFirstCharachter = exports.convertStringToDecimal = exports.extractAllWordsBeforeLastSpace = exports.extractLastWord = void 0;
var extractLastWord = function (text) {
    if (text && text != null) {
        var words = text.trim().split(" ");
        return words[words.length - 1];
    }
};
exports.extractLastWord = extractLastWord;
var extractAllWordsBeforeLastSpace = function (text, separator) {
    if (text && text != null) {
        var words = text.trim().split(separator);
        var wordsBeforeLast = words.slice(0, words.length - 1);
        return wordsBeforeLast.join(separator);
    }
};
exports.extractAllWordsBeforeLastSpace = extractAllWordsBeforeLastSpace;
var convertStringToDecimal = function (str) {
    return parseFloat(str);
};
exports.convertStringToDecimal = convertStringToDecimal;
var removeFirstCharachter = function (str) {
    if (str != null) {
        return str.slice(1);
    }
    else {
        return null;
    }
};
exports.removeFirstCharachter = removeFirstCharachter;
var hyphenateString = function (str) {
    var lowercased = str.toLowerCase();
    return lowercased.replace(/[\s_]/g, "-");
};
exports.hyphenateString = hyphenateString;
var camelCaseString = function (str) {
    return str
        .split(/[^a-zA-Z0-9]+/)
        .map(function (word, index) {
        return index === 0
            ? word.toLowerCase()
            : word.charAt(0).toUpperCase() + word.slice(1).toLowerCase();
    })
        .join('');
};
exports.camelCaseString = camelCaseString;
